# Contributing to 'Redux Duplicate Action Monitor'

The following is a set of guidelines for contributing to 'Redux Duplicate Action Monitor'. Please spend several minutes in reading these guidelines before you create an issue or pull request.

Anyway, these are just guidelines, not rules, use your best judgment and feel free to propose changes to this document in a pull request.


## Do your homework before asking a question

It's a great idea to read Eric Steven Raymond's [How To Ask Questions The Smart Way](http://www.catb.org/esr/faqs/smart-questions.html) twice before asking a question. But if you are busy now, I recommend to read [Don't post homework questions](http://www.catb.org/esr/faqs/smart-questions.html#homework) first.

The following guidelines are about *How to avoid Homework Questions*.

## Read the documentation.

Please read the documentation closely. Most answers will be here but if its not clear let me know!

## Close your issue if it's solved

It is a good habit which will save maintainers' time. Thank you!

## Providing a demo while reporting a bug

It would be helpful to provide a demo which can re-produce the bug 100%. Please fork this project and re-produce the bug you met in the repo or provide detailed instructions to reproduce the issue. Then, create an issue. The most important thing is: double check before claiming that you have found a bug.

## Tips about Feature Request

If you believe that 'Redux Duplicate Action Monitor' should provide some features, but it does not. You could create an issue to discuss.

## Tips about Pull Request

**Working on your first Pull Request?** You can learn how from this *free* series [How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github)

It's welcomed to pull request. And there are some tips about that:

1. It is a good habit to create a feature request issue to discuss whether the feature is necessary before you implement it. However, it's unnecessary to create an issue to claim that you found a typo or improved the readability of documentation, just create a pull request.
1. Rebase before creating a PR to keep commit history clear.
1. Add some descriptions and refer relative issues for you PR.
